/*=======================================================================================================
                                        Функция работы таймера по прерыванию
=======================================================================================================*/
void Timing_ISR()
{
  Encode();

  if (Zar == 1) Sec[0]++;
  Sec[1]++; Sec[3]++; Sec[4]++; Sec[5]++; Sec[6]++; Sec[7]++; Sec[8]++;

  if (Beep_ON == 1) {digitalWrite(Beep, HIGH); Beep_ON = 2;}
/*-----------------------------------------------------------------------------------------------------*/
  if (Zar == 1)
  {
    if ((Curr[0] <= Curr[2] - 0.2) || (Curr[0] >= Curr[2] + 0.2)) {T_Curr = 50; Ind_C = 300;}
    else {T_Curr = 1000; Ind_C = 1000;}

    if ((Select >= 3) && (Select <= 7))
    {
      if (Volt[0] >= Volt_Lim[Select]) 
      {
        Zar = 0; Select = 0; Level = Tmp_V[0]; Sec[3] = 0; Beep_ON = 1;
         Beep_OFF = 2; Sec[8] = 0; Ind_C = 300;
      }
    }

    if (Select == 8)
    {
      if (Flag_Plum[0] == 0) {if (Volt[0] >= Volt_Lim[Select] - 2) Curr[2] /= 2; Flag_Plum[0] = 1;}
      if (Volt[0] >= Volt_Lim[Select]) 
      {
        Zar = 0; Select = 0; Level = Tmp_V[0]; Sec[3] = 0; Beep_ON = 1;
        Flag_Plum[0] = 0; Ind_C = 300; Beep_OFF = 2; Sec[8] = 0;
      }
    }

    if (Select == 9) 
    {
      if (Flag_Plum[1] == 0)
      {
        if (Volt[0] >= Volt_Lim[Select]) 
        {
          if (Curr[0] >= Curr[2] - 0.1) Curr[2] -= 0.1; 
          Flag_Plum[1] = 1; Sec[3] = 200; Beep_ON = 1; Ind_C = 300;
        }
      }
      if (Curr[0] <= Curr[2]) Flag_Plum[1] = 0;
      if (Curr[2] <= Curr_End / 2) 
      {
        Zar = 0; Select = 0; Sec[3] = 0; Curr_End = 0; Ind_C = 300;
        Level = Tmp_V[0]; Beep_ON = 1; Beep_OFF = 2; Sec[8] = 0; Flag_Plum[1] = 0;
      }
    }
  }
/*-----------------------------------------------------------------------------------------------------*/
  if (digitalRead(But_Zar) == 0)
  {
    digitalWrite(Beep, HIGH); Sec[3] = 0;
    while (digitalRead(But_Zar) == 0) { }               // Ожидаем отпускания кнопки
    
    switch(Zar)
    {
      case 0:
              if (Select >= 3) Zar = 1; 
              Level = Tmp_V[Select]; //Ind_C = 1000;
              if (Curr_End == 0) Curr_End = Curr[2];
      break;
      case 1:
              Zar = 0; Level = Tmp_V[0]; Ind_C = 300;
              Flag_Plum[0] = 0; Flag_Plum[1] = 0; 
              Dw = 0; Zero_Curr();
      break;
    }
    Beep_ON = 2;
  }
/*-----------------------------------------------------------------------------------------------------*/
  if (Sec[8] >= 1000)                                     // 1 сек
  {
    Sec[8] = 0; 
    if (Beep_OFF >= 1)                                    // Три долгих гудка в тумане
    {
      Beep_OFF--; digitalWrite(Beep, HIGH); Beep_ON = 2; Sec[3] = 0;
    }
  }
/*-----------------------------------------------------------------------------------------------------*/
  if (Sec[7] >= Ind_C)                                    // 0.5 сек
  {
    Sec[7] = 0; Indic();
  }
/*-----------------------------------------------------------------------------------------------------*/
  if (Sec[6] >= T_Curr)                                 // 
  {
    Sec[6] = 0;
    if (Select >= 3)
    {
      if (Zar == 1)
      {
        if (Curr[0] <= Curr[2] - 0.01) Level--;
        if (Curr[0] >= Curr[2] + 0.01) Level++;

        Tmp_L = Level;
        if (Tmp_L >= Var_L) Tmp_L = Var_L;
        if (Tmp_L <= 1)  Tmp_L = 1;
        PWM_set(PWM_OUT, Tmp_L);
      }
    }  
  }
/*-----------------------------------------------------------------------------------------------------*/
  if (Select == 1)
  {
    if (Sec[5] >= 10000)                                // 10 сек
    {
      Select = 0; digitalWrite(Beep, HIGH); Beep_ON = 2; Sec[3] = 0;
    }
  }
/*-----------------------------------------------------------------------------------------------------*/
  if (Sec[4] >= 1000)                                   // 1 сек
  {
    Sec[4] = 0;
    Frequens[0] = Frequens[1]; Frequens[1] = 0;         // Запоминаем частоту вращения
  }
/*-----------------------------------------------------------------------------------------------------*/
  if (Beep_ON == 2)
  {
    if (Sec[3] >= 300)                                   // 0.3 cek
    {
      digitalWrite(Beep, LOW); Beep_ON = 0;
    }
  }
/*-----------------------------------------------------------------------------------------------------*/
  if (Select >= 3)
  {
    if (Zar == 1)
    {
      if (Sec[1] >= 1000)                                    // 1 сек
      {
        Sec[1] = 0;
        switch (Dw)
        {
          case 0: Dw = 1; break;
          case 1: Dw = 0; break;
        }
      }
    }
    else Dw = 0;
  }
/*-----------------------------------------------------------------------------------------------------*/
  if (Select <= 2)
  {
    Input_C    = Curr[2];
    Setpoint_C = Curr[0];
    PID_CUR.Compute();
    Tmp_L = Level + Output_C;
    if (Tmp_L >= Var_L) Tmp_L = Var_L;
    if (Tmp_L <= 1)  Tmp_L = 1;
    PWM_set(PWM_OUT, Tmp_L);
  }
/*-----------------------------------------------------------------------------------------------------*/
  if (Select >= 3)
  {
    if (Zar == 1)                                         // Счетчик Времени
    {
      if (Sec[0]  >= 1000) {Sec[0]    = 0; Second[0]++;}
      if (Second[0] >= 60) {Second[0] = 0; Minute[0]++;}
      if (Minute[0] >= 60) {Minute[0] = 0; Hour[0]++;}
    }
  }
/*=======================================================================================================
                                           Обработчик прерывания 1 мс
=======================================================================================================*/
  TimeCount++;
  if (TimeCount >= 1020)
  {
    Flag_Cels = 1;
    TimeCount = 0;
    FlagSensReady_AK = true;
    FlagSensReady_BP = true;
  }
  if (TimeCount == 2)  DS_AK.reset();                       // сброс шины
  if (TimeCount == 4)  DS_BP.reset();                       // сброс шины
  if (TimeCount == 8)  DS_AK.write(0xCC, POWER_MODE);       // пропуск ROM
  if (TimeCount == 10) DS_BP.write(0xCC, POWER_MODE);       // пропуск ROM
  if (TimeCount == 14) DS_AK.write(0x44, POWER_MODE);       // инициализация измерения
  if (TimeCount == 16) DS_BP.write(0x44, POWER_MODE);       // инициализация измерения
  
  if (TimeCount == 971) {Present_AK = 0; Present_BP = 0;}
  if (TimeCount == 972) Present_AK = DS_AK.reset();         // Сигнал наличия датчика температуры
  if (TimeCount == 973) Present_BP = DS_BP.reset();         // Сигнал наличия датчика температуры

  if (TimeCount == 975) DS_AK.reset();                      // сброс шины
  if (TimeCount == 976) DS_BP.reset();                      // сброс шины
  if (TimeCount == 978) DS_AK.write(0xCC, POWER_MODE);      // пропуск ROM
  if (TimeCount == 979) DS_BP.write(0xCC, POWER_MODE);      // пропуск ROM
  if (TimeCount == 981) DS_AK.write(0xBE, POWER_MODE);      // команда чтения памяти датчика
  if (TimeCount == 982) DS_BP.write(0xBE, POWER_MODE);      // команда чтения памяти датчика

  if (TimeCount == 984)  bufData_AK[0] = DS_AK.read();      // чтение памяти датчика
  if (TimeCount == 985)  bufData_BP[0] = DS_BP.read();      // чтение памяти датчика
  if (TimeCount == 987)  bufData_AK[1] = DS_AK.read();      // чтение памяти датчика
  if (TimeCount == 988)  bufData_BP[1] = DS_BP.read();      // чтение памяти датчика
  if (TimeCount == 990)  bufData_AK[2] = DS_AK.read();      // чтение памяти датчика
  if (TimeCount == 991)  bufData_BP[2] = DS_BP.read();      // чтение памяти датчика
  if (TimeCount == 993)  bufData_AK[3] = DS_AK.read();      // чтение памяти датчика
  if (TimeCount == 994)  bufData_BP[3] = DS_BP.read();      // чтение памяти датчика
  if (TimeCount == 996)  bufData_AK[4] = DS_AK.read();      // чтение памяти датчика
  if (TimeCount == 997)  bufData_BP[4] = DS_BP.read();      // чтение памяти датчика
  if (TimeCount == 999)  bufData_AK[5] = DS_AK.read();      // чтение памяти датчика
  if (TimeCount == 1000) bufData_BP[5] = DS_BP.read();      // чтение памяти датчика
  if (TimeCount == 1002) bufData_AK[6] = DS_AK.read();      // чтение памяти датчика
  if (TimeCount == 1003) bufData_BP[6] = DS_BP.read();      // чтение памяти датчика
  if (TimeCount == 1005) bufData_AK[7] = DS_AK.read();      // чтение памяти датчика
  if (TimeCount == 1006) bufData_BP[7] = DS_BP.read();      // чтение памяти датчика
  if (TimeCount == 1008) bufData_AK[8] = DS_AK.read();      // чтение памяти датчика
  if (TimeCount == 1009) bufData_BP[8] = DS_BP.read();      // чтение памяти датчика
}
/*=====================================================================================================*/
