/*=======================================================================================================
                                              Вывод на индикатор
=======================================================================================================*/
void Indic()
{
  u8g.setFont(Rus_10x20);
  u8g.setFontPosTop();
  
  u8g.firstPage();
  do 
  {
    u8g.drawLine(0, 38, 127, 38);                     // Горизонтальная линия
    u8g.drawLine(77, 38, 77, 64);                     // Вертикальная линия
    u8g.drawLine(108, 0, 108, 38);                    // Вертикальная линия
    u8g.drawLine(20, 0, 20, 38);                      // Вертикальная линия
    u8g.drawFrame(0, 0, 128, 64);                     // Рисуем прямоугольник 128х64 пикселей
    u8g.setColorIndex(3);                             // Определяем закрасить (1) или нет (0)
    
    if (Volt[0] <= 9.9) {u8g.setPrintPos(37, 3); u8g.print(Volt[0], 3); u8g.drawStr(93,  3, "V");}
    else {u8g.setPrintPos(27, 3); u8g.print(Volt[0], 3); u8g.drawStr(93, 3, "V");}
    
    if (Curr[0] <= 9.9) {u8g.setPrintPos(37, 18); u8g.print(Curr[0], 3); u8g.drawStr(93, 18, "A");}
    else {u8g.setPrintPos(27, 18); u8g.print(Curr[0], 3); u8g.drawStr(93, 18, "A");}
    
    u8g.setColorIndex(3);                             // Определяем закрасить (1) или нет (0)
    u8g.setFont(rus6x10);

    switch (Select)
    {
      case 0: u8g.drawStr(27, 50, "POWER");     break;
      case 1: u8g.drawStr(20, 50, "CURRENT");   break;
      case 2: u8g.drawStr(27, 50, "DRELL");     break;
      case 3: u8g.drawStr(14, 50, "Li-Ion 2S"); break;
      case 4: u8g.drawStr(14, 50, "Li-Ion 3S"); break;
      case 5: u8g.drawStr(14, 50, "Li-Ion 4S"); break;
      case 6: u8g.drawStr(14, 50, "Li-Ion 5S"); break;
      case 7: u8g.drawStr(14, 50, "Li-Ion 6S"); break;
      case 8: u8g.drawStr(19, 50, "Plumbum");   break;
      case 9: u8g.drawStr(17, 50, "Plum_Gel");  break;
   }

    u8g.drawStr(5, 60, "PWM "); u8g.setPrintPos(27, 60); u8g.print(Tmp_L); u8g.setPrintPos(55, 60); u8g.print(Curr[2], 1);
    u8g.setPrintPos(85, 50); u8g.print(Cels_AK[0], 1); u8g.drawStr(115, 50, "C");

    Freq[0] = Frequens[0] / 100;
    Freq[1] = (Frequens[0] % 100) / 10;
    Freq[2] = Frequens[0] % 10;

    if (Frequens[0] >= 100)
    {
      u8g.setPrintPos(116, 12); u8g.print(Freq[0]);
      u8g.setPrintPos(116, 23); u8g.print(Freq[1]);
      u8g.setPrintPos(116, 34); u8g.print(Freq[2]);
    }
    else
    {
      u8g.setPrintPos(116, 17); u8g.print(Freq[1]);
      u8g.setPrintPos(116, 28); u8g.print(Freq[2]);
    }

    Cls[0] = (byte)Cels_BP[0] / 10;
    Cls[1] = (byte)Cels_BP[0] % 10;
    
    u8g.setPrintPos(8, 17); u8g.print(Cls[0]);
    u8g.setPrintPos(8, 28); u8g.print(Cls[1]);

    u8g.setPrintPos( 85, 60); u8g.print(Hour[0] / 10);
    u8g.setPrintPos( 92, 60); u8g.print(Hour[0] % 10);
    if (Dw == 0) {u8g.setPrintPos(100, 60); u8g.print(":");}
    else {u8g.setPrintPos(100, 60); u8g.print(" ");}
    u8g.setPrintPos(108, 60); u8g.print(Minute[0] / 10);
    u8g.setPrintPos(115, 60); u8g.print(Minute[0] % 10);
  }
  while(u8g.nextPage()); 
  delay(10);
}
/*=====================================================================================================*/
